f.enr.prefilter <- function (GO.list, sample.Entrez, thrGN.min.n = 4, thrGN.max.n = 500, thrEN.n = 3)

# < thrGN.n > base gene number threshold: GO terms with less than threshold number of genes will be neglected
# < thrEN.n > enriched gene number threshold: GO terms enriched by less than threshold number of genes will be neglected

{

# <GOf.list> holds GO.list entries passing filters; <j> is their counter

GOf.list <- list ()
l.n <- length (GO.list)

for (i in 1: l.n) 
        {

        # pre-filtering
        genes.n <- unique (GO.list[[i]])
        if (length (genes.n) < thrGN.min.n || length (genes.n) > thrGN.max.n)
                {next}
        if (length (intersect (sample.Entrez, genes.n)) < thrEN.n)
                {next}

        GOID.ch <- names (GO.list)[i]
        GOf.list[[GOID.ch]] <- unique (GO.list[[i]])
        }

return (GOf.list)

}