# set working dir
setwd ("/Users/danielemerico/Documents/Research_Works/Utility/Mouse2Human_Orthology/Core_Data")

all.df <- read.table (
			file = "homologene.data",
			sep  = "\t",
			quote  = "",
			header = F,
			stringsAsFactors = F)

colnames (all.df) <- c ("Serial_N", "Taxon_ID", "Gene_ID", "Symbol", "Unknown_ID","GenBank")

# * Human Taxon_ID: 9606
# * Mouse Taxon_ID: 10090

Taxon_H.n = 9606
Taxon_M.n = 10090

# these are all the serial numbers where
# I have both a human and a mouse entry

z.serial_N.nv <- unique (
				intersect (
					all.df$Serial_N[all.df$Taxon_ID == Taxon_H.n], 
					all.df$Serial_N[all.df$Taxon_ID == Taxon_M.n]))

# define data frame in which I will put
# the IDs and symbols

z.l <- length (z.serial_N.nv)

Human2Mouse.df <- data.frame (
					H_ID     = numeric (z.l),
					H_Symbol = character (z.l),
					M_ID     = numeric (z.l),
					M_Symbol = character (z.l),
					stringsAsFactors = F)

# in this cycle I will grab couples of orthologs
# and put them into the data frame
# I will use the serial number as key

i <- 1
while (i < z.l)
	{
	z.serial.n <- z.serial_N.nv[i]
	temp.df <- all.df[all.df$Serial_N %in% z.serial.n, ]
	H_G <- temp.df$Gene_ID[temp.df$Taxon_ID == Taxon_H.n]
	H_S <- temp.df$Symbol [temp.df$Taxon_ID == Taxon_H.n]
	M_G <- temp.df$Gene_ID[temp.df$Taxon_ID == Taxon_M.n]
	M_S <- temp.df$Symbol [temp.df$Taxon_ID == Taxon_M.n]

	# count how many mappings I have	
	H.n <- length (H_G)
	M.n <- length (M_G)
	
	for (h in 1: H.n)
		{
		for (m in 1: M.n)
			{
			Human2Mouse.df$H_ID[i]     <- H_G[h]
			Human2Mouse.df$H_Symbol[i] <- H_S[h]
			Human2Mouse.df$M_ID[i]     <- M_G[m]
			Human2Mouse.df$M_Symbol[i] <- M_S[m]
			i = i + 1
			}
		}
	
	# OLD This original check revealed that there are multiple mappings

	# OLD if (length (temp.df$Gene_ID[temp.df$Taxon_ID == Taxon_H.n]) > 1 | 
	# OLD	length (temp.df$Gene_ID[temp.df$Taxon_ID == Taxon_M.n]) > 1)
	# OLD	{print (temp.df)}

	if (H.n + M.n > 2)
		{print (paste ("Multiple at position:", i))}

	if (i %% 25 == 0)
		print (paste ("Done", i))
	}